class Bub{

    static void swap(int[] a,int i,int j){
        int temp=a[i];  
        a[i]=a[j];  
        a[j]=temp;
    }
    // trova la posizione del pi piccolo elemento nell'array, tra 0 e size-1
    static int searchMin(int[] a,int size){
        int pos=0;
        for (int i=0;i<size;i++)
            if (a[i]<a[pos]) pos=i;
        return pos;
    }
    // trova la posizione del pi grande elemento nell'array, tra 0 e size-1
    static int searchMax(int[] a,int size){
        int pos=0;
        for (int i=0;i<size;i++)
            if (a[i]>a[pos]) pos=i;
        return pos;
    }

    static void bubbleSort(int[] a){
        boolean ordered;
        do{
            ordered=true;
            for (int i=0;i<a.length-1;i++)
                if (a[i]>a[i+1]){
                    swap(a,i,i+1);
                    ordered=false;
                }
            System.out.println(arrayToString(a));
        } while (!ordered);
    }

    static void mixedBubbleSort(int[] a){
        boolean ordered;
        boolean way=true;
        do{
            ordered=true;
            if (way){
            for (int i=0;i<a.length-1;i++)
                if (a[i]>a[i+1]){
                    swap(a,i,i+1);
                    ordered=false;
                }
            } else
                for (int j=a.length-1;j>1;j--)
                    if (a[j]<a[j-1]){
                        swap(a,j,j-1);
                        ordered=false;
                    }
            way=!way;
            System.out.println(arrayToString(a));
        } while (!ordered);
    }

    static String arrayToString(int[] a){
        String s="(";
        for (int i=0;i<a.length;i++){
            if (i>0) s=s+",";
            s=s+""+a[i];
        }
        return s+")";
    }

    static int fattoriale(int n){ return n==0?1:n*fattoriale(n-1);}
    static boolean occurs(int[] a,int n){
        for(int i=0;i<a.length;i++)
            if (a[i]==n) return true;
        return false;
    }
    static int[] add(int[] a,int n){
        int[] out=new int[a.length+1];
        for(int i=0;i<a.length;i++)
            out[i]=a[i];
        out[a.length]=n;
        return out;
    }

    static int[][] permuta(int[] a){
        if (a.length==0) return new int[][]{};
        int[][] out=new int[fattoriale(a.length)][a.length];
        permuta2(a,out,0,new int[]{});
        return out;
    }
    static int permuta2(int[] a,int[][] out,int start,int[] current){
        if (current.length==a.length) {
            out[start]=current;
            return start+1;
        }
        for (int i=0;i<a.length;i++){
            if (!occurs(current,a[i]))
                start=permuta2(a,out,start,add(current,a[i]));
        }
        return start;
    }
    static void stampa(int[][] out){
        for (int i=0;i<out.length;i++) System.out.println(arrayToString(out[i]));
    }

    static long performBubble(int n){
        int[] a=new int[n];
        for (int i=0;i<n;i++) a[i]=i;
        int[][] out=permuta(a);
        long time=System.currentTimeMillis();
        for (int i=0;i<out.length;i++) bubbleSort(out[i]);
        return System.currentTimeMillis()-time;
    }
    static long performMixedBubble(int n){
        int[] a=new int[n];
        for (int i=0;i<n;i++) a[i]=i;
        int[][] out=permuta(a);
        long time=System.currentTimeMillis();
        for (int i=0;i<out.length;i++) mixedBubbleSort(out[i]);
        return System.currentTimeMillis()-time;
    }


    public static void main(String[] s){
        for (int i=0;i<10000;i++) System.out.println(""+System.currentTimeMillis());
        System.out.println("bubble "+performBubble(10));
        System.out.println("mixed "+performMixedBubble(10));
    }

}

