public class Esame{
    static boolean beginsWith(int[] a,int[] b){
        if (b.length>a.length) return false;
        for (int i=0;i<b.length;i++)
                if (a[i]!=b[i]) return false;
        return true;
    }
    static boolean endsWith(int[] a,int[] b){
        if (b.length>a.length) return false;
        for (int i=0;i<b.length;i++)
                if (a[a.length-i-1]!=b[b.length-i-1]) return false;
        return true;
    }
    static boolean sameStarting(int[] a,int[] b){
        for (int i=0;i<a.length && i<b.length;i++)
            if (a[i]!=b[i]) return false;
        return true;
    }
    static boolean sameEnding(int[] a,int[] b){
        for (int i=0;i<a.length && i<b.length;i++)
            if (a[a.length-i-1]!=b[b.length-i-1]) return false;
        return true;
    }
    
    static boolean beginsWithR(int[] a,int[] b){
        if (b.length>a.length) return false; else return beginsWithR(a,b,0);
    }
    static boolean beginsWithR(int[] a,int[] b,int i){
        if (i==b.length) return true;
        if (a[i]==b[i]) return beginsWithR(a,b,i+1);
        return false;
    }
    
    static boolean endsWithR(int[] a,int[] b){
        if (b.length>a.length) return false; else return endsWithR(a,b,0);
    }
    static boolean endsWithR(int[] a,int[] b,int i){
        if (i==b.length) return true;
        if (a[a.length-i-1]==b[b.length-i-1]) return endsWithR(a,b,i+1);
        return false;
    }
    
    static boolean sameStartingR(int[] a,int[] b){
        return sameStartingR(a,b,0);
    }
    
    static boolean sameStartingR(int[] a,int[] b,int i){
        if (i==b.length || i==a.length) return true;
        if (a[i]==b[i]) return sameStartingR(a,b,i+1);
        return false;
    }
    
    static boolean sameEndingR(int[] a,int[] b){
        return sameEndingR(a,b,0);
    }
    
    static boolean sameEndingR(int[] a,int[] b,int i){
        if (i==b.length || i==a.length) return true;
        if (a[a.length-i-1]==b[b.length-i-1]) return sameEndingR(a,b,i+1);
        return false;
    }
    
    static boolean testBeginsWith(){ 
        int[] a=new int[]{1,2,3,4,5};
        int[] b=new int[]{1,2,3};
        int[] c=new int[]{2,3,4};
        return beginsWith(a,b) && !beginsWith(b,a) && !beginsWith(a,c) && 
                beginsWith(new int[0],new int[0]) && beginsWith(b,new int[0]) && !beginsWith(new int[0],b);
    }
    
    static boolean testEndsWith(){ 
        int[] a=new int[]{1,2,3,4,5};
        int[] b=new int[]{3,4,5};
        int[] c=new int[]{2,3,4};
        return endsWith(a,b) && !endsWith(b,a) && !endsWith(a,c) && 
                endsWith(new int[0],new int[0]) && endsWith(b,new int[0]) && !endsWith(new int[0],b);
    }
    
    static boolean testSameStarting(){
        int[] a=new int[]{1,2,3,4,5};
        int[] b=new int[]{1,2,3};
        int[] c=new int[]{2,3,4};
        return sameStarting(a,b) && sameStarting(b,a) && !sameStarting(a,c) && 
                sameStarting(new int[0],new int[0]) && sameStarting(b,new int[0]) && sameStarting(new int[0],b);
    }
    
    static boolean testSameEnding(){ 
        int[] a=new int[]{1,2,3,4,5};
        int[] b=new int[]{3,4,5};
        int[] c=new int[]{2,3,4};
        return sameEnding(a,b) && sameEnding(b,a) && !sameEnding(a,c) && 
                sameEnding(new int[0],new int[0]) && sameEnding(b,new int[0]) && sameEnding(new int[0],b);
    }
    
    static boolean testBeginsWithR(){ 
        int[] a=new int[]{1,2,3,4,5};
        int[] b=new int[]{1,2,3};
        int[] c=new int[]{2,3,4};
        return beginsWithR(a,b) && !beginsWithR(b,a) && !beginsWithR(a,c) && 
                beginsWithR(new int[0],new int[0]) && beginsWithR(b,new int[0]) && !beginsWithR(new int[0],b);
    }
    
    static boolean testEndsWithR(){ 
        int[] a=new int[]{1,2,3,4,5};
        int[] b=new int[]{3,4,5};
        int[] c=new int[]{2,3,4};
        return endsWithR(a,b) && !endsWithR(b,a) && !endsWithR(a,c) && 
                endsWithR(new int[0],new int[0]) && endsWithR(b,new int[0]) && !endsWithR(new int[0],b);
    }
    
    static boolean testSameStartingR(){ 
        int[] a=new int[]{1,2,3,4,5};
        int[] b=new int[]{1,2,3};
        int[] c=new int[]{2,3,4};
        return sameStartingR(a,b) && sameStartingR(b,a) && !sameStartingR(a,c) && 
                sameStartingR(new int[0],new int[0]) && sameStartingR(b,new int[0]) && sameStartingR(new int[0],b);
    }
    
    static boolean testSameEndingR(){ 
        int[] a=new int[]{1,2,3,4,5};
        int[] b=new int[]{3,4,5};
        int[] c=new int[]{2,3,4};
        return sameEndingR(a,b) && sameEndingR(b,a) && !sameEndingR(a,c) && 
                sameEndingR(new int[0],new int[0]) && sameEndingR(b,new int[0]) && sameEndingR(new int[0],b);
    }
    
    
    static int[] generaQ1(int n){
        if (n<0) return new int[0];
        int size=1;
        for (;2*size+1<=n;size++);   // 2*size+1 == (size+1)*(size+1)-size*size
        int[] out=new int[size+1];
        for (int i=0;i<out.length;i++) out[i]=(i+1)*(i+1);
        return out;
    }
    
    static boolean testGeneraQ1(){
        return arrayEquals(generaQ1(-5),new int[0]) &&
               arrayEquals(generaQ1(0),new int[]{1,4}) &&
               arrayEquals(generaQ1(1),new int[]{1,4}) &&
               arrayEquals(generaQ1(2),new int[]{1,4}) &&
               arrayEquals(generaQ1(3),new int[]{1,4,9}) &&
               arrayEquals(generaQ1(4),new int[]{1,4,9}) &&
               arrayEquals(generaQ1(5),new int[]{1,4,9,16}) &&
               generaQ1(17).length==10;
    }
    
    
    static int[] generaQ2(int n){
        if (n<0) return new int[0];
        int size=2;
        for (;4*size<=n;size++);   // 4*size == (size+1)*(size+1)-(size-1)*(size-1)
        int[] out=new int[size+1];
        for (int i=0;i<out.length;i++) out[i]=(i+1)*(i+1);
        return out;
    }
    
    static boolean testGeneraQ2(){
        return arrayEquals(generaQ2(-5),new int[0]) &&
               arrayEquals(generaQ2(0),new int[]{1,4,9}) &&
               arrayEquals(generaQ2(1),new int[]{1,4,9}) &&
               arrayEquals(generaQ2(2),new int[]{1,4,9}) &&
               arrayEquals(generaQ2(3),new int[]{1,4,9}) &&
               arrayEquals(generaQ2(7),new int[]{1,4,9}) &&
               arrayEquals(generaQ2(8),new int[]{1,4,9,16}) &&
               arrayEquals(generaQ2(11),new int[]{1,4,9,16}) &&
               arrayEquals(generaQ2(12),new int[]{1,4,9,16,25}) &&
               generaQ2(17).length==6;
    }
    
    static int[] generaD1(int n){
        if (n<0) return new int[0];
        int size=1;
        for (;8*size<=n;size++);     // 8*size == (2*size+1)*(2*size+1)-(2*(size-1)+1)*(2*(size-1)+1)
        int[] out=new int[size+1];
        for (int i=0;i<out.length;i++) out[i]=2*i+1;
        return out;
    }
    
    static boolean testGeneraD1(){
        return arrayEquals(generaD1(-5),new int[0]) &&
               arrayEquals(generaD1(0),new int[]{1,3}) &&
               arrayEquals(generaD1(1),new int[]{1,3}) &&
               arrayEquals(generaD1(2),new int[]{1,3}) &&
               arrayEquals(generaD1(7),new int[]{1,3}) &&
               arrayEquals(generaD1(8),new int[]{1,3,5}) &&
               arrayEquals(generaD1(9),new int[]{1,3,5}) &&
               arrayEquals(generaD1(15),new int[]{1,3,5}) &&
               arrayEquals(generaD1(16),new int[]{1,3,5,7}) &&
               generaD1(25).length==5;
    }
    
    
    static int[] generaD2(int n){
        if (n<0) return new int[0];
        int size=2;
        for (;16*size-8<=n;size++);   // 16*size-8 == (2*size+1)*(2*size+1)-(2*(size-2)+1)*(2*(size-2)+1)
        int[] out=new int[size+1];
        for (int i=0;i<out.length;i++) out[i]=2*i+1;
        return out;
    }
    
    static boolean testGeneraD2(){
        return arrayEquals(generaD2(-5),new int[0]) &&
               arrayEquals(generaD2(0),new int[]{1,3,5}) &&
               arrayEquals(generaD2(1),new int[]{1,3,5}) &&
               arrayEquals(generaD2(2),new int[]{1,3,5}) &&
               arrayEquals(generaD2(23),new int[]{1,3,5}) &&
               arrayEquals(generaD2(24),new int[]{1,3,5,7}) &&
               arrayEquals(generaD2(25),new int[]{1,3,5,7}) &&
               arrayEquals(generaD2(39),new int[]{1,3,5,7}) &&
               arrayEquals(generaD2(40),new int[]{1,3,5,7,9}) &&
               generaQ2(67).length==6;
    }
    
    public static void main(String[] s){
        System.out.println(""+testBeginsWith());
        System.out.println(""+testEndsWith());
        System.out.println(""+testSameStarting());
        System.out.println(""+testSameEnding());
        System.out.println("--");
        System.out.println(""+testBeginsWithR());
        System.out.println(""+testEndsWithR());
        System.out.println(""+testSameStartingR());
        System.out.println(""+testSameEndingR());
        System.out.println("--");
        System.out.println(""+testGeneraQ1());
        System.out.println(""+testGeneraQ2());
        System.out.println("--");
        System.out.println(""+testGeneraD1());
        System.out.println(""+testGeneraQ2());
    }
    
    static boolean arrayEquals(int[] a,int[] b){
        if (a.length!=b.length) return false;
        for (int i=0;i<a.length;i++)
            if (a[i]!=b[i]) return false;
        return true;
    }
    static String arrayToString(int[] a){
        String s="";
        for (int i=0;i<a.length;i++) s+=a[i]+";";
        return s;
    }
    
        
}
