public class Sequence{
	
	private static int initialSize(){
		return 10;
	}
	
/*Creazione del array bidimensionale*/
	public static int[][] createVoid(){
		return new int[][]{new int[initialSize()],new int[]{0}};
	}
	
/*Controlla se il numero indicato nel secondo array [1][0]  pari alla 
 *lunghezza del primo*/ 
	private static boolean isFull(int[][] seq){
		return (seq[1][0]==seq[0].length);
	}
	
/*Crea un nuovo array lungo il doppio, ci copia tutti gli elementi del 
 *primo array e lo mette nel suo posto*/
  	private static void increase(int[][] seq){
        int[] inc=new int[seq[0].length*2];
        for (int i=0;i<seq[0].length;i++)
            inc[i]=seq[0][i];
        seq[0]=inc;
    }
    
/*Se c' ancora spazio mette nel primo array nella posizione (incrementata 
 *di 1) indicata dal secondo array l'elemento e.*/
    public static void append (int[][] seq,int e){
    	if (isFull(seq)) increase(seq);
    	seq[0][seq[1][0]++]=e;
    }
    	
	public static void appendMany(int[][] seq,int[] e){
		for (int i=0;i<e.length;i++)
			append(seq,e[i]);
	}
	
/*Dall'esercitazione 6*/
	/*Divede nella posizione pos la sequenza. La parte finale la mette 
	 *in una nuova sequenza di nome out e modifica la sequenza di ingresso 
	 *eliminando la parte finale*/ 
	public static int[][] split(int[][] seq,int pos){
		int[][] out=createVoid();
		for (int i=pos;i<length(seq);i++)
			append(out,seq[0][i]);
		seq[1][0]=pos;
		return out;
	}
	 
/*Diminuisce il numero contenuto nel secondo array privando di 
 *considerazione l'ultimo numero del primo array*/	
	public static void dropLast(int[][] seq){
		seq[1][0]--;
	}
	
/*Restituisce il numero del primo array nella posizione indicata*/
	public static int get(int[][] seq,int pos){
        return seq[0][pos];
    }

/*Restitusce la lunghezza del primo array (solo del pezzo considerato)*/
    public static int length(int[][] seq){
        return seq[1][0];
    }

//Converte il primo array di seq in un altro array    
    public static int[] toArray(int[][] seq){
        int[] out=new int[seq[1][0]];
        for (int i=0;i<out.length;i++)
            out[i]=seq[0][i];
        return out;
    }

    public static String toString(int[][] seq){
        String s="(";
        for (int i=0;i<length(seq);i++)
            s+=(i>0?",":"")+get(seq,i);
        return s+")";
    }
}