/**
 * Questa classe rappresenta l'astrazione di Data
 * in termini di giorno, mese, anno.
 */
public class ACMEDate {

    private int day;
    private int month;
    private int year;

    /**
     * Costruisce una data dato il giorno, mese ed anno
     * @param day e' il giorno
     * @param month e' il mese
     * @param year e' l'anno
     */
    public ACMEDate(int day, int month, int year){
        this.day=day;
        this.month=month;
        this.year=year;
    }

    /**
     * Restituisce il giorno
     *
     * @return il giorno (da 1 a 31)
     */
    public int getDay(){
        return day;
    }

    /**
     * Restituisce il mese
     *
     * @return il mese (da 1 a 12)
     */
    public int getMonth(){
        return month;
    }

    /**
     * restituisce l'anno
     *
     * @return l'anno
     */
    public int getYear(){
        return year;
    }

    /**
     * Restituisce una rappresentazione testuale di questa data
     * nel formato dd/mm/yyyy
     *
     * @return una stringa che rappresenta la data
     */
    public String toString(){
        return ""+day+"/"+month+"/"+year;
    }
}
