/**
 * Questa classe estende la classe ACMEPlotter modificando i metodi della classe 
 * base: ad ognuno di essi  stato aggiunta una linea di codice che stampa su 
 * standard output quello che fanno.
 * 
 * @author Andrea Urbini
 */


public class ACMEPlotterLog extends ACMEPlotter{
	
	/**
	 * Costruisce un oggetto ACMEPlotterLog
	 */
	
	public ACMEPlotterLog(){
		super();
	}
	
	/**
	 * Alza il pennino virtuale
	 */
	
	public void up(){
		super.up();
		System.out.println("E' stato alzato il pennino virtuale");
	}
	
	/**
	 * Abbassa il pennino viruale
	 */
	
	public void down(){
		super.down();
		System.out.println("E' stato abbasato il pennino virtuale");
	}
	
	/**
	 * Sposta il pennino virtuale a punto p
	 * @param p punto di arrivo del pennino
	 */
	
	public void moveTo(Point p){
		super.moveTo(p);
		System.out.println("E' stato spostato il pennino virtuale alla posizione "+p.toString());
	}
	
	/**
	 * Definisce il colore del pennino 
	 * @param r tonalita' di rosso
	 * @param g tonalita' di verde
	 * @param b tonalita' di blu
	 */
	
	public void setColor(double r,double g,double b){
		super.setColor(r,g,b);
		System.out.println("E' stato definito il seguente colore: rosso="+r+", verde="+g+", blu="+b);
	}
	
	/**
	 * Definisce lo spessore del pennino
	 * @param s spessore del tratto del pennino
	 */
	
	public void setThickness(int s){
		super.setThickness(s);
		System.out.println("E' stato definito uno spessore di "+s);
	}
	
}