/**
 * Questa classe rappresenta l'astrazione di una figura geometrica generica
 * caratterizzata da un colore e uno spessore del pennino che la disegna.
 *
 * @author Andrea Urbini
 */  

public class Figura{
	
	//Campi privati
	private int spessore;
	private double r,g,b;
	
	/**
	 * Costruisce un oggetto di tipo Figura
	 * @param r tonalita' di rosso
	 * @param g tonalita' di verde
	 * @param b tonalita' di blu
	 * @param spessore spessore del pennino
	 */
	 
	public Figura(double r,double g,double b,int spessore){
		this.r=r;
		this.g=g;
		this.b=b;
		this.spessore=spessore;
	}
	
	/**
	 * Disegna la figura generica. In questo caso setta solo il colore del 
	 * pennino e il suo spessore
	 * @param tavola plotter su cui va disegnata la figura.
	 */ 
	
	public void disegna(Plotter tavola){
		tavola.setColor(r,g,b);
		tavola.setThickness(spessore);
	}
}