/**
 * Questa classe rappresenta l'astrazione di una linea caratterizzata da un 
 * colore e uno spessore del pennino che la disegna. Inoltre vanno definiti 
 * anche i due punti estremi.  
 *
 * @author Andrea Urbini
 */ 

public class Line extends Figura{
	
	private Point p1,p2;
	
	/**
	 * Costruisce un oggetto di tipo Line
	 * @param p1 primo punto del segmento
	 * @param p2 secondo punto del segmento
	 * @param r tonalita' di rosso
	 * @param g tonalita' di verde
	 * @param b tonalita' di blu
	 * @param spessore spessore del pennino
	 */
	
	
	public Line(Point p1,Point p2,double r,double g,double b,int spessore){
		super(r,g,b,spessore);
		this.p1=p1;
		this.p2=p2;
	}
	
	/**
	 * Disegna la linea sul plotter in ingresso. 
	 * @param tavola plotter su cui va disegnata la linea.
	 */ 
	
	public void disegna(Plotter tavola){
		super.disegna(tavola);
		tavola.up();
		tavola.moveTo(p1);
		tavola.down();
		tavola.moveTo(p2);
	}
}