/**
 *
 * Questa classe rappresenta un punto nello spazio bidimensionale
 *
 * @author  Eureka software
 * @version 0.1
 */
public class Point {

    /** 
     * Crea un nuovo punto, date le coordinate
     *
     * @param x - coordinata X del punto
     * @param y - coordinata Y del punto
     */
    public Point(double x,double y) {
        this.x=x;
        this.y=y;
    }

    /**
     * Restituisce la coordinata X del punto
     *
     * @return valore della coordinata X
     */
    public double getX(){
        return x;
    }

    /**
     * Restituisce la coordinata Y del punto
     *
     * @return valore della coordinata Y
     */
    public double getY(){
        return y;
    }

    /**
     * Restituisce la rappresentazione testuale del punto,
     * nel formato (X,Y)
     *
     * @return stringa "(X,Y)", dove X e Y sono le coordinate del punto
     */
    public String toString(){
        return "("+x+","+y+")";
    }

    private double x;
    private double y;
}
