/**
 * Questa classe rappresenta l'astrazione di un poligono caratterizzato da un 
 * colore e uno spessore del pennino che lo disegna. Inoltre va definito 
 * anche l'array dei suoi vertici. 
 *
 * @author Andrea Urbini
 */ 

public class Poligono extends Figura{
	
	private Point[] vertici;
	
	/**
	 * Costruisce un oggetto di tipo Poligono
	 * @param vertici array contenente i vertici del poligono
	 * @param r tonalita' di rosso
	 * @param g tonalita' di verde
	 * @param b tonalita' di blu
	 * @param spessore spessore del pennino
	 */
	
	public Poligono(Point[] vertici,double r,double g,double b,int spessore){
		super(r,g,b,spessore);
		this.vertici=vertici;
	}
	
	/**
	 * Disegna il poligono sul plotter in ingresso.
	 * @param tavola plotter su cui va disegnato il poligono.
	 */ 
	
	public void disegna(Plotter tavola){
		super.disegna(tavola);
		//Sposta il pennino al primo vertice del poligono
		tavola.up();
		tavola.moveTo(vertici[0]);
		tavola.down();
		//Collega tutti i vertici
		for (int i=1;i<vertici.length;i++){
			tavola.moveTo(vertici[i]);
		}
		//Collega l'ultimo vertice con il primo.
		tavola.moveTo(vertici[0]);
	}
}