/**
 * Questo componente software testa le funzionalita'
 * del plotter virtuale.  Viene creato un plotter e
 * poi vi si interagisce, invocandone metodi che
 * alzano, abbassano il pennino virtuale
 * e spostandolo in modo da tracciare linee
 * nell'area del plotter.
 *
 * Per uscire dal programma in esecuzione
 * chiudere la finestra del plotter stesso.
 *
 * @author Eureka software
 * @version 0.1
 */
public class TestPlotter {
    static public void main(String[] args){

        // creiamo un plotter
        Plotter plotter = new Plotter();

        // settiamo il colore rosso puro
        plotter.setColor(1,0,0);

        // alziamo il pennino
        plotter.up();

        // spostiamo il pennino in posizione (0.5,0.5)
        plotter.moveTo(new Point(0.5,0.4));

        // abbassiamo il pennino
        plotter.down();

        // ci muoviamo in modo da tracciare una
        // forma quadrangolare chiusa
        plotter.moveTo(new Point(0.8,-0.35));
        plotter.moveTo(new Point(-1,-0.5));
        plotter.moveTo(new Point(-0.2,0.8));
        plotter.moveTo(new Point(0.5,0.4));

        // settiamo come spessore il valore 3
        plotter.setThickness(3);

        // settiamo come colore il verde puro
        plotter.setColor(0,1,0);

        // spostiamo il pennino fino all'origine
        plotter.moveTo(new Point(0,0));

    }
}
