package es04;

/**
 * Questa classe rappresenta l'astrazione di uno spettacolo identificato da 
 * un nome. Un oggetto Spectacle contiene anche informazioni sui posti 
 * prenotati e occupati. 
 * @author Andrea Urbini
 */

public class Spectacle{
	
	private String name;
	private int[] bookedSeats,boughtSeats;
	
	/**
	 * Crea un oggetto di tipo Spectacle caratterizzato da una stringa name.
	 * @param name nome dello spettacolo.
	 */  
	
	public Spectacle(String name){
		this.name=name;
		bookedSeats=new int[0];
		boughtSeats=new int[0];
	}
	
	/**
	 * Fornisce una stringa contenente nome dello spettacolo.
	 * @return il nome dello spettacolo.
	 */
	
	public String getName(){
		return name;
	}
	
	/**
	 * Fornisce l'array dei posti che sono stati occupati
	 * @return posti occupati.
	 */
	 
	public int[] getBookedSeats(){
		return bookedSeats;
	}
	
	/**
	 * Fornisce l'array dei posti che sono stati acquistati
	 * @return posti acquistati.
	 */
	
	public int[] getBoughtSeats(){
		return boughtSeats;
	}
	
	/**
	 * Aggiorna l'array dei posti prenotati
	 * @param seats array dei posti da occupare.
	 */ 
	
	public void setBookedSeats(int[] seats){
		bookedSeats=seats;
	}
	
	/**
	 * Aggiorna l'array dei posti acquistati
	 * @param seats array dei posti da acquistare.
	 */ 
	
	public void setBoughtSeats(int[] seats){
		boughtSeats=seats;
	}
		
}	