package es04;

/**
 * Interfaccia dei servizi per la
 * prenotazione dei posti e acquisto dei biglietti.
 *
 * @see BookingNote
 */
public interface TicketService {

    /**
     * Servizio per prenotare i posti di uno spettacolo. Si specificano le informazioni
     * sullo spettacolo da vedere e sui i posti da prenotare; il servizio prenota i posti
     * e restituisce una prenotazione contenente tali informazioni.
     *
     * @param spectacleName Nome dello spettacolo
     * @param seats elenco dei posti da prenotare.  Ogni posto e' caratterizzato da un intero
     *        che rappresenta il numero di posto a sedere.
     *
     * @return Se l'operazione ha successo viene restituita una prenotazione,
     *         al contrario se l'operazione non riesce (perche' non esiste lo spettacolo,
     *         oppure perche' i posti descritti non sono validi, oppure perche' i posti descritti
     *         sono gia' prenotati) viene restituito il valore null.
     */
    BookingNote bookTickets(String spectacleName, int[] seats);

    /**
     * Servizio per comprare i biglietti, per i quali deve
     * esser stata fatta una prenotazione con l'apposito servizio
     * <code>bookTickets</code>
     *
     * @param note la prenotazione, ottenuta con il servizio per la prenotazione <code>bookTickets</code>
     * @return true se l'acquisto ha avuto successo, false
     *         se l'acquisto non ha avuto successo
     *         (perche' ad esempio la prenotazione che contiene non e' valida, oppure
     *         perche' e' gia' stata usata per acquistare i biglietti in precedenza)
     */
    boolean buyTickets(BookingNote note);

}
