package es05;

import java.awt.*;
import javax.swing.*;

/**
 * Questo componente software contiene le operazioni per la creazione della 
 * finestra del programma.
 * Per avviare il programma occorre lanciare questa classe.
 * 
 * @author Andrea Urbini
 */
 
public class ACMEPaint{
	
	private static int x=400,y=400;
	
	/**
	 * Contiene le operazioni di creazione e visualizzazione dell'interfaccia 
	 * grafica.
	 */
	
	public static void main(String[] args){
		//creo un oggetto Toolkit per ottenere le dimensioni dello schermo
		Toolkit tk=Toolkit.getDefaultToolkit(); 
		Dimension d=tk.getScreenSize();
		//creo la finestra
		JFrame finestra=new JFrame("ACMEPaint");
		finestra.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		finestra.setSize(new Dimension(x,y));
		//centro la finestra nello schermo
		finestra.setLocation((int)(d.getWidth()-x)/2,(int)(d.getHeight()-y)/2);
		finestra.setResizable(false);
		//Estraggo il container dal JFrame
		Container c=finestra.getContentPane();
		//Definisco il layout del container
		c.setLayout(new BorderLayout());
		//creo i tre pannelli e li aggiungo al container
		CenterPanel center=new CenterPanel();
		c.add(center,BorderLayout.CENTER);
		SouthPanel south=new SouthPanel(center);
		c.add(south,BorderLayout.SOUTH);
		NorthPanel north=new NorthPanel(center);
		c.add(north,BorderLayout.NORTH);
		//mostro la finestra sul desktop
		finestra.show();
	}	
}
		