package es05;

import java.awt.Color;

/**
 * Questa classe rappresenta l'astrazione di un segmento caratterizzato da 4 
 * coordinate (i due punti estremi) e da un colore.  
 * @author andrea urbini
 */

public class Line{
	
	private int x1,x2,y1,y2;
	private Color colore;
	
	/**
	 * Costruttore
	 * @param x1 ascissa del primo estremo.
	 * @param y1 ordinata del primo estremo.
	 * @param x2 ascissa del secondo estremo.
	 * @param y2 ordinata del secondo estremo.
	 * @param colore colore del segmento
	 */
	
	public Line(int x1,int y1,int x2,int y2,Color colore){
		this.x1=x1;
		this.x2=x2;
		this.y1=y1;
		this.y2=y2;
		this.colore=colore;
	}
	
	/**
	 * Ritorna l'ascissa del primo estremo
	 * @return x1;
	 */
	
	public int getX1(){
		return x1;
	}
	
	/**
	 * Ritorna lordinata del primo estremo
	 * @return y1;
	 */
	
	public int getY1(){
		return y1;
	}
	
	/**
	 * Ritorna l'ascissa del secondo estremo
	 * @return x2;
	 */
	
	public int getX2(){
		return x2;
	}
	
	/**
	 * Ritorna l'ordinata del secondo estremo
	 * @return y2;
	 */
	
	public int getY2(){
		return y2;
	}
	
		/**
	 * Ritorna il colore del segmento
	 * @return colore;
	 */
	
	public Color getColor(){
		return colore;
	}
}