package es05;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

/**
 * Questa classe estende la classe JPanel definendo un nuovo panello che 
 * corrisponde alla parte inferiore della finestra di ACMEPaint.   
 * @author Andrea Urbini
 */

public class SouthPanel extends JPanel{
	
	CenterPanel ascoltatore;
	
	/**
	 * Questo metodo costruisce un oggetto SouthPanel.
	 * @param center pannello centrale, cioe' quello su cui si agisce premendo i bottoni.
	 */
	
	public SouthPanel(CenterPanel ascoltatore){
		super();
		this.ascoltatore=ascoltatore;
		String[] colori=new String[]{"Nero","Rosso","Giallo","Verde","Blu"};
		//creazione della JComboBox dei colori: non e' editabile dall'utente e 
		//gli eventi che genera sono acoltati da questa classe. 
		JComboBox colorList=new JComboBox(colori);
		colorList.setEditable(false);
		colorList.addActionListener(ascoltatore);
		add(colorList);
		//creazione del bottone
		JButton up=new JButton("U");
		up.addActionListener(ascoltatore);
		add(up);
		//creazione del bottone
		JButton down=new JButton("D");
		down.addActionListener(ascoltatore);
		add(down);
		//creazione del bottone
		JButton left=new JButton("L");
		left.addActionListener(ascoltatore);
		add(left);
		//creazione del bottone
		JButton right=new JButton("R");
		right.addActionListener(ascoltatore);
		add(right);
		//creazione del bottone
		JButton quit=new JButton("Quit");
		quit.addActionListener(ascoltatore);
		add(quit); 
	}

}