package es06;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.util.Calendar;

/**
 *Questa classe costruisce la finestra rappresentante il controllore. Qui 
 *l'utente puo' inserire i valori soglia delle grandezze. Quesat classe ascolta 
 *gli eventi generati dai componenti della classe Sensor.
 *@author Andrea Urbini
 */

public class Controll implements ActionListener,ChangeListener{
	
	int pressioneSoglia,pressioneCorrente;
	double temperaturaSoglia,temperaturaCorrente,prodottoSoglia;
	JButton aggiorna;
	JTextField tempSoglia,presSoglia,prodSoglia;
	Viewer ascoltatore1;
	Saver ascoltatore2;
	
	/**
	 *Costruisce il JFrame relativo al controllore 
	 *@param ascoltatore oggetto che ascolta gli eventi generati nella classe 
	 */
	 
	public Controll(Viewer ascoltatore1,Saver ascoltatore2){
		this.ascoltatore1=ascoltatore1;
		this.ascoltatore2=ascoltatore2;
		
		//Creo il frame di controllo
		JFrame controlFrame=new JFrame("Controllore");
		controlFrame.setBounds(10,120,300,130);
		controlFrame.setResizable(false);
		controlFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		Container cc=controlFrame.getContentPane();
		JPanel controlPanel=new JPanel();
		JLabel tempLabel=new JLabel("Temperatura Soglia (C):");
		Box colonna1=new Box(BoxLayout.Y_AXIS);
		Box colonna2=new Box(BoxLayout.Y_AXIS);
		tempSoglia=new JTextField("38",5);
		tempSoglia.setHorizontalAlignment(JTextField.RIGHT);
		JLabel presLabel=new JLabel("Pressione Soglia:");
		presSoglia=new JTextField("200",4);
		presSoglia.setHorizontalAlignment(JTextField.RIGHT);
		JLabel prodLabel=new JLabel("Pressione * Temperatura Soglia:");
		prodSoglia=new JTextField("700",5);
		prodSoglia.setHorizontalAlignment(JTextField.RIGHT);
		aggiorna=new JButton("Aggiorna");
		aggiorna.addActionListener(this);
		colonna1.add(tempLabel);
		colonna1.add(presLabel);
		colonna2.add(tempSoglia);
		colonna2.add(presSoglia);
		colonna1.add(prodLabel);
		colonna2.add(prodSoglia);
		controlPanel.add(colonna1);
		controlPanel.add(colonna2);
		controlPanel.add(aggiorna);		
		cc.add(controlPanel);
		controlFrame.show();
		temperaturaSoglia=Double.parseDouble(tempSoglia.getText());
		pressioneSoglia=Integer.parseInt(presSoglia.getText());
		prodottoSoglia=Double.parseDouble(prodSoglia.getText());
	}
	
	/**
	 * Ascoltatore degli eventi generati dai componenti JButton e JTextField 
	 * rispettivamente delle classi Controll e Sensor. In particolare rileva i 
	 * valori del JTextField di Sensor (temperatura corrente) e dei JTextField 
	 * di Controll (temperatura Soglia, pressione Soglia e pressione * 
	 * temperatura Soglia). Se i valori correnti superano le soglie manda 
	 * un messaggio al visualizzatore.
	 * @param e evento di tipo ActionEvent
	 */
	
	public void actionPerformed(ActionEvent e){
		String actionName=e.getActionCommand();
		//Se premo aggiorna si aggiornano i valori soglia. 
		if (actionName.equals("Aggiorna")){
			temperaturaSoglia=Double.parseDouble(tempSoglia.getText());
			pressioneSoglia=Integer.parseInt(presSoglia.getText());
			prodottoSoglia=Double.parseDouble(prodSoglia.getText());
		}else{
			//Altrimenti, per esclusione, l'evento proviene dal JTextField della temperatura corrente.
			temperaturaCorrente=Double.parseDouble(((JTextField)e.getSource()).getText());
			if (temperaturaCorrente>temperaturaSoglia){
				String messaggio=data()+" il valore della temperatura ha superato il valore \n soglia ("+temperaturaSoglia+"): "+temperaturaCorrente+"\n\n";
				ascoltatore1.addMessage(messaggio);
				ascoltatore2.addMessage(messaggio);
			}
			if (temperaturaCorrente*pressioneCorrente>prodottoSoglia){
				String messaggio=data()+" il valore del prodotto temperatura*pressione ha superato il valore \n soglia ("+prodottoSoglia+"): "+temperaturaCorrente*pressioneCorrente+"\n\n";
				ascoltatore1.addMessage(messaggio);
				ascoltatore2.addMessage(messaggio);
			}
		}
	}
	
	/**
	 * Ascoltatore degli eventi generati dal componente JSlider della classe 
	 * Sensor. Se il valore indicato sullo JSlider supera il valore della 
	 * pressione di soglia manda un messaggio al visualizzatore.
	 * @param e evento generato dal JSlider
	 */
	
	public void stateChanged(ChangeEvent e){
		JSlider presValore=(JSlider)e.getSource();
		pressioneCorrente=presValore.getValue();
		if (pressioneCorrente>pressioneSoglia){
			String messaggio=data()+" il valore della pressione massima ha superato il valore \n soglia ("+pressioneSoglia+"): "+pressioneCorrente+"\n\n";
			ascoltatore1.addMessage(messaggio);
			ascoltatore2.addMessage(messaggio);
		}
		if (temperaturaCorrente*pressioneCorrente>prodottoSoglia){
				String messaggio=data()+" il valore del prodotto temperatura*pressione ha superato il valore \n soglia ("+prodottoSoglia+"): "+temperaturaCorrente*pressioneCorrente+"\n\n";
				ascoltatore1.addMessage(messaggio);
				ascoltatore2.addMessage(messaggio);
		}
			
	}
	
	/**
	 * Questo metodo crea una stringa contente le informazioni sulla data nel
	 * seguente formato:
	 * Giorno della settimana, giorno del mese, mese, anno, ora, minuti, secondi.
	 * @return stringa contente la data.
	 */
	
	public String data(){
		String s=" ";
		//creo un oggetto Calendar
		Calendar calendario=Calendar.getInstance();
		//recupero il giorno della settimana e gli assegno il nome italiano
		int giorno=calendario.get(Calendar.DAY_OF_WEEK);
		if (giorno==1) s+="Domenica";
		else if(giorno==2) s+="Lunedi'";
		else if(giorno==3) s+="Martedi'";
		else if(giorno==4) s+="Mercoledi'";
		else if(giorno==5) s+="Giovedi'";
		else if(giorno==6) s+="Venerdi'";
		else s+="Sabato";
		//recupero il giorno del mese 
		s+=" "+calendario.get(Calendar.DAY_OF_MONTH)+" ";
		//recupero il mese e gli assegno il nome italiano
		int mese=calendario.get(Calendar.MONTH);
		if (mese==0) s+="Gennaio";
		else if(mese==1) s+="Febbraio";
		else if(mese==2) s+="Marzo";
		else if(mese==3) s+="Aprile";
		else if(mese==4) s+="Maggio";
		else if(mese==5) s+="Giugno";
		else if(mese==6) s+="Luglio";
		else if(mese==7) s+="Agosto";
		else if(mese==8) s+="Settembre";
		else if(mese==9) s+="Ottobre";
		else if(mese==10) s+="Novembre";
		else s+="Dicembre";
		//recupero l'anno
		s+=" "+calendario.get(Calendar.YEAR);
		//trasformo in stringa l'orario
		s+=" - "+calendario.get(Calendar.HOUR_OF_DAY)+":"+calendario.get(Calendar.MINUTE)+":"+calendario.get(Calendar.SECOND)+" - ";
		return s;
	}
}