package es06;

import java.awt.*;
import javax.swing.*;

/**
 *Questa classe crea le due finestre corrispondenti ai due sensori.
 *@author Andrea Urbini
 */

public class Sensor{
	
	Controll ascoltatore;
	
	/**
	 *Costruisce i deu JFrame con i due sensori: un JSlider e un JTextField
	 *@param ascoltatore oggetto che ascolta gli eventi generati nella classe
	 */
	
	public Sensor(Controll ascoltatore){
		this.ascoltatore=ascoltatore;
		
		//realizzo il frame del sensore di pressione
		JFrame presFrame=new JFrame("Sensore di pressione");
		presFrame.setBounds(10,10,300,100);
		presFrame.setResizable(false);
		presFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		Container cp=presFrame.getContentPane();
		JPanel presPanel=new JPanel();
		JLabel presLabel=new JLabel("Valore corrente");
		presPanel.add(presLabel);
		JSlider presValore=new JSlider(0,300,150);
		presValore.setMajorTickSpacing(300);
 		presValore.setMinorTickSpacing(1);
  		presValore.setPaintLabels(true);
		presValore.addChangeListener(ascoltatore);
		presPanel.add(presValore);
		cp.add(presPanel);
		presFrame.show();
		
		//Realizzo il frame del sensore di temperatura 
		JFrame tempFrame=new JFrame("Sensore di temperatura");
		tempFrame.setBounds(320,10,300,100);
		tempFrame.setResizable(false);
		tempFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		Container ct=tempFrame.getContentPane();
		JPanel tempPanel=new JPanel();
		JLabel tempLabel=new JLabel("Valore corrente (C):");
		tempPanel.add(tempLabel);
		JTextField tempValore=new JTextField("36.51",5);
		tempValore.setHorizontalAlignment(JTextField.RIGHT);
		tempValore.addActionListener(ascoltatore);
		tempPanel.add(tempValore);
		ct.add(tempPanel);
		tempFrame.show();
	}
}
	