package es06;

import java.awt.*;
import javax.swing.*;

/**
 * Questa classe crea la finestra corrispondente al visualizzatore.
 * @author Andrea Urbini
 */

public class Viewer{
	
	JTextArea viewerText;
	JPanel viewerPanel;
	
	/**
	 * Costruisce il JFrame corrispondente al componente di visualizzazione.
	 */
	
	public Viewer(){
		JFrame viewerFrame=new JFrame("Visualizzatore");
		viewerFrame.setBounds(10,260,610,220);
		viewerFrame.setResizable(false);
		viewerFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		Container cv=viewerFrame.getContentPane();
		viewerPanel=new JPanel();
		viewerText=new JTextArea(9,54);
		viewerText.setEnabled(false);
		JScrollPane viewerScroll=new JScrollPane(viewerText); 
		viewerScroll.setWheelScrollingEnabled(true); 
		viewerPanel.add(viewerScroll);
		cv.add(viewerPanel);
		viewerFrame.show();
	}
	
	/**
	 * Questo metodo scrive sulla TextArea del pannello la stringa message 
	 * passata in ingresso.
	 * @param message messaggio da visualizzare sul pannello.
	 */
	
	public void addMessage(String message){
		//aggiungo alla JTextArea il messaggio
		viewerText.append(message);
		//ridisegno il pannello
		viewerPanel.repaint();
	}	
}